module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 7);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("prop-types");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("react-bootstrap");

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(8));
__export(__webpack_require__(5));
__export(__webpack_require__(9));


/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("lodash");

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const PropTypes = __webpack_require__(1);
const react_bootstrap_1 = __webpack_require__(2);
const core_1 = __webpack_require__(6);
class Server extends React.Component {
    get footer() {
        const { server } = this.props;
        const { renderer } = this.context;
        return (React.createElement("div", { className: `row text-center ${renderer.renderRule(styles.footer.container)}` },
            React.createElement("div", { className: `col-sm-12 ${renderer.renderRule(styles.footer.column)}` },
                React.createElement("strong", null, "Docker Server"))));
    }
    get description() {
        const { server: { description } } = this.props;
        const { renderer } = this.context;
        return description.split('\n').map((line, index) => React.createElement("p", { key: index, className: `${renderer.renderRule(styles.description)}` }, line));
    }
    render() {
        const _a = this.props, { server, remove, routeTo, onSettings } = _a, rest = __rest(_a, ["server", "remove", "routeTo", "onSettings"]);
        const { renderer } = this.context;
        return (React.createElement(react_bootstrap_1.Panel, Object.assign({ footer: this.footer }, rest, { className: renderer.renderRule(styles.box), bsStyle: "default" }),
            React.createElement("div", { className: "panel-content" },
                React.createElement("div", { className: "information" },
                    React.createElement("div", { key: 0, className: renderer.renderRule(styles.name) },
                        React.createElement("span", null,
                            React.createElement("i", { className: `
                                    indicator
                                    glyphicon
                                    glyphicon-certificate
                                    ${renderer.renderRule(styles.status)}
                                    -${server.status}
                                    ` })),
                        " ",
                        React.createElement("strong", null,
                            server.name,
                            " | ",
                            server.status),
                        React.createElement("div", { className: "pull-right" },
                            React.createElement(react_bootstrap_1.DropdownButton, { className: `${renderer.renderRule(styles.menu)}`, pullRight: true, noCaret: true, bsSize: "xsmall", bsStyle: "default", title: React.createElement("i", { className: "glyphicon glyphicon-option-vertical" }), id: `workspace-dropdown-${server.id}` },
                                React.createElement(react_bootstrap_1.MenuItem, { key: 1, onClick: e => onSettings() }, "Settings"),
                                React.createElement(react_bootstrap_1.MenuItem, { key: 2, divider: true }),
                                React.createElement(react_bootstrap_1.MenuItem, { key: 3, onClick: e => confirm('Are you shure?') && remove(server.id) }, "Remove")))),
                    React.createElement("div", { key: 1 }, this.description)))));
    }
}
Server.contextTypes = {
    renderer: PropTypes.object.isRequired,
};
exports.Server = Server;
const styles = {
    box: props => ({
        borderRadius: '1px !important',
    }),
    name: props => ({
        fontSize: '16px',
        margin: '0 0 5px 0',
    }),
    description: props => ({
        fontSize: '12px',
        margin: 0,
        ':first-child': {
            marginTop: '5px',
        },
    }),
    status: props => ({
        [`&.-${core_1.WorkspaceStatus.WORKSPACE_STATUS_CONNECTED}`]: ({
            color: '#449d44',
        }),
        [`&.-${core_1.WorkspaceStatus.WORKSPACE_STATUS_DISCONNECTED}`]: ({
            color: '#ababab',
        }),
        [`&.-${core_1.WorkspaceStatus.WORKSPACE_STATUS_PENDING}`]: ({
            color: '#ec971f',
        }),
    }),
    menu: props => ({
        border: 'none !important',
        ':hover': {
            background: 'transparent !important',
            boxShadow: 'none !important',
        },
        ':visited': {
            background: 'transparent !important',
            boxShadow: 'none !important',
        },
        ':focus': {
            background: 'transparent !important',
            boxShadow: 'none !important',
        },
    }),
    footer: {
        container: props => ({}),
        column: props => ({
            fontSize: '12px',
        }),
    },
};


/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("@adminide-stack/core");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(3));
__export(__webpack_require__(10));
__export(__webpack_require__(14));


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const _ = __webpack_require__(4);
const React = __webpack_require__(0);
const PropTypes = __webpack_require__(1);
const react_bootstrap_1 = __webpack_require__(2);
const Server_1 = __webpack_require__(5);
class List extends React.Component {
    constructor(context, props) {
        super(context, props);
        this.state = {
            filter: false,
        };
    }
    get list() {
        const { filter, status, servers } = this.props;
        const result = filter || status
            ? servers
                .filter(workspace => filter ? workspace.name.toLowerCase().includes(filter.toLowerCase()) : true)
                .filter(workspace => status ? workspace.status === status : true)
            : servers;
        return result.map((workspace, _index) => (Object.assign({}, workspace, { _index })));
    }
    render() {
        const { renderer } = this.context;
        const { remove, routeTo, onNewServer, onServerSettings } = this.props;
        const rows = _.groupBy(this.list, function (workspace) {
            return Math.floor(workspace._index % 3);
        });
        return (React.createElement("div", { className: `${renderer.renderRule(styles.list)} ${_.isEmpty(rows) && '-empty'}` }, !_.isEmpty(rows) ? (React.createElement(react_bootstrap_1.Row, null, _.map(rows, (elements, colIndex) => (React.createElement(react_bootstrap_1.Col, { key: colIndex, sm: 4 }, elements.map(server => (React.createElement(Server_1.Server, { server: server, onSettings: () => onServerSettings(server), key: server.id, remove: remove, routeTo: routeTo })))))))) : (React.createElement("div", { className: `${renderer.renderRule(styles.centered)}` },
            React.createElement("h3", null, "Nothing to show..."),
            React.createElement(react_bootstrap_1.Button, { onClick: () => onNewServer(), bsStyle: "primary" }, "Register new server")))));
    }
}
List.contextTypes = {
    renderer: PropTypes.object.isRequired,
};
List.defaultProps = {
    servers: [],
    status: '',
    filter: '',
};
exports.List = List;
const styles = {
    list: props => ({
        width: '100%',
        display: 'flex',
        'flex-direction': 'column',
        'flex-grow': 1,
        '&.-empty': {
            'align-items': 'center',
            'justify-content': 'center',
        },
    }),
    centered: props => ({
        'text-align': 'center',
    }),
};


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const PropTypes = __webpack_require__(1);
const react_bootstrap_1 = __webpack_require__(2);
class TopNavigation extends React.Component {
    render() {
        const { user } = this.props;
        const { renderer } = this.context;
        return (React.createElement(react_bootstrap_1.Navbar, { fluid: true, className: `top-navigation ${renderer.renderRule(styles.topNavigation)}` },
            React.createElement(react_bootstrap_1.Navbar.Header, null,
                React.createElement(react_bootstrap_1.Navbar.Brand, null,
                    React.createElement("a", { href: "#" }, "Admin IDE | Servers"))),
            React.createElement(react_bootstrap_1.Navbar.Collapse, null,
                React.createElement(react_bootstrap_1.Nav, { pullRight: true },
                    React.createElement(react_bootstrap_1.NavItem, { eventKey: 1, href: "#" },
                        React.createElement("i", { className: "glyphicon glyphicon-cog" }),
                        " Settings"),
                    React.createElement(react_bootstrap_1.NavItem, { onClick: () => this.props.onCreate(), eventKey: 2, href: "javascript:void(0)" },
                        React.createElement("i", { className: "glyphicon glyphicon-plus" }),
                        " Create new"),
                    React.createElement(react_bootstrap_1.NavDropdown, { eventKey: 3, title: user.email, id: "navbar-account-dropdown" },
                        React.createElement(react_bootstrap_1.MenuItem, { eventKey: 3.1 }, "Account"),
                        React.createElement(react_bootstrap_1.MenuItem, { divider: true }),
                        React.createElement(react_bootstrap_1.MenuItem, { eventKey: 3.4 }, "Logout"))))));
    }
}
TopNavigation.contextTypes = {
    renderer: PropTypes.object.isRequired,
};
exports.TopNavigation = TopNavigation;
const styles = {
    topNavigation: () => ({
        'margin-bottom': '0 !important',
        'flex-grow': 0,
    }),
};


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(11));


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const PropTypes = __webpack_require__(1);
const lodash_1 = __webpack_require__(4);
const react_apollo_1 = __webpack_require__(12);
const react_bootstrap_1 = __webpack_require__(2);
const graphql_gql_1 = __webpack_require__(13);
const core_1 = __webpack_require__(6);
const components_1 = __webpack_require__(3);
function isDuplicateServer(newServer, existingServers = []) {
    return existingServers.some(server => newServer.id === server.id);
}
exports.isDuplicateServer = isDuplicateServer;
class DashboardComponent extends React.Component {
    constructor(props, context) {
        super(props, context);
        this.state = {};
    }
    componentWillReceiveProps(nextProps) {
        if (!this.subscription && !nextProps.loading) {
            this.subscription = this.props.subscribeToMore({
                document: graphql_gql_1.SERVERS_SUBSCRIPTION,
                variables: {
                    filter: {},
                    mutations: ['createServer', 'updateServer', 'deleteServer']
                },
                updateQuery: (previousResult, { subscriptionData }) => {
                    const { subscribeToServers } = subscriptionData.data;
                    console.log(subscriptionData);
                    if (subscribeToServers) {
                        const { mutation, value } = subscribeToServers;
                        if (mutation === 'deleteServer') {
                            const newResult = Object.assign({}, previousResult, {
                                serversList: lodash_1.filter(previousResult.serversList, item => item.id !== value.id),
                            });
                            return newResult;
                        }
                        if (isDuplicateServer(value, previousResult.boxes)) {
                            return previousResult;
                        }
                        const newResult = Object.assign({}, previousResult, {
                            serversList: [...previousResult.serversList, value],
                        });
                        return newResult;
                    }
                },
            });
        }
    }
    render() {
        const { renderer } = this.context;
        const { empty, create, remove, loading, serversList } = this.props;
        return (React.createElement("div", { className: `dashboard ${renderer.renderRule(styles.page)}` },
            React.createElement(components_1.TopNavigation, { user: { email: 'test@dispostable.com' } }),
            React.createElement("div", { className: renderer.renderRule(styles.dashboard) }, loading ? React.createElement("h1", { className: renderer.renderRule(styles.loading) }, "Loading...") : (React.createElement("div", { className: renderer.renderRule(styles.content) },
                React.createElement("div", { className: renderer.renderRule(styles.header.wrapper) },
                    React.createElement("h1", { className: renderer.renderRule(styles.header.title) }, "Workspaces"),
                    React.createElement("div", { className: `${renderer.renderRule(styles.header.search)} row` },
                        React.createElement(react_bootstrap_1.FormGroup, { className: "col-md-6", style: { margin: 0 } },
                            React.createElement(react_bootstrap_1.FormControl, { type: "text", placeholder: "Search...", onChange: e => this.setState({ filter: e.target.value }) })),
                        React.createElement(react_bootstrap_1.FormGroup, { className: "col-md-6", style: { margin: 0 } },
                            React.createElement(react_bootstrap_1.FormControl, { componentClass: "select", onChange: e => this.setState({ status: e.target.value }) },
                                React.createElement("option", { value: "" }, "All"),
                                React.createElement("option", { value: core_1.WorkspaceStatus.WORKSPACE_STATUS_CONNECTED }, "Connected"),
                                React.createElement("option", { value: core_1.WorkspaceStatus.WORKSPACE_STATUS_DISCONNECTED }, "Disconnected"),
                                React.createElement("option", { value: core_1.WorkspaceStatus.WORKSPACE_STATUS_PENDING }, "Pending"))))),
                React.createElement(components_1.List, { filter: this.state.filter, status: this.state.status, onNewServer: () => this.setState({ modal: true }), onServerSettings: box => this.setState({ modal: true, box }), servers: serversList, create: create, remove: remove }))))));
    }
}
DashboardComponent.contextTypes = {
    renderer: PropTypes.object.isRequired,
};
const styles = ({
    page: props => ({
        display: 'flex',
        width: '100%',
        'flex-direction': 'column',
    }),
    dashboard: props => ({
        height: '100%',
        display: 'flex',
        'flex-grow': '1',
        'flex-direction': 'row',
    }),
    content: props => ({
        width: '100%',
        padding: '15px 15px 0 15px',
        height: '100%',
        display: 'flex',
        'flex-direction': 'column',
    }),
    loading: props => ({
        margin: 0,
        width: '100%',
        'text-align': 'center',
        'align-self': 'center',
        'justify-content': 'center',
        'display': 'flex',
        'flex-direction': 'column',
    }),
    header: {
        wrapper: props => ({
            display: 'flex',
            'flex-grow': '0',
            'flex-direction': 'row',
            'margin-bottom': '15px',
        }),
        title: props => ({
            margin: 0,
            'flex-grow': 2,
        }),
        search: props => ({
            'flex-grow': 1,
            'justify-content': 'center',
            'align-self': 'center',
        }),
    },
});
exports.Dashboard = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.SERVERS_LIST, {
    props: ({ data: { loading, serversList, subscribeToMore } }) => ({ serversList, loading, subscribeToMore }),
}), react_apollo_1.graphql(graphql_gql_1.CREATE_SERVER, {
    props: ({ mutate }) => ({
        create: variables => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.UPDATE_SERVER, {
    props: ({ mutate }) => ({
        update: variables => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.REMOVE_SERVER, {
    props: ({ mutate }) => ({
        remove: id => mutate({ variables: { id } }),
    }),
}))(DashboardComponent);


/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 13 */
/***/ (function(module, exports) {

module.exports = require("@container-stack/graphql-gql");

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const Fela = __webpack_require__(15);
const react_fela_1 = __webpack_require__(16);
exports.createRenderer = (fontNode) => {
    const renderer = Fela.createRenderer({
        plugins: [],
        enhancers: [],
    });
    return renderer;
};
exports.getProvider = (node) => story => (React.createElement(react_fela_1.Provider, { renderer: exports.createRenderer(node) }, story()));


/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("fela");

/***/ }),
/* 16 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map