/// <reference types="react" />
import * as React from 'react';
import * as PropTypes from 'prop-types';
import { IServer } from '@container-stack/core';
export interface ListProps {
    servers: IServer[];
    create?: Function;
    routeTo?: Function;
    remove?: Function;
    onNewServer?: Function;
    onServerSettings?: Function;
    filter?: string;
    status?: string;
}
export declare class List extends React.Component<ListProps, any> {
    static contextTypes: {
        renderer: PropTypes.Validator<any>;
    };
    static defaultProps: {
        servers: any[];
        status: string;
        filter: string;
    };
    constructor(context: any, props: any);
    readonly list: {
        _index: number;
        id?: string;
        ip: string;
        name: string;
        description?: string;
        type: string;
        status: string;
    }[];
    render(): JSX.Element;
}
